/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Interrupt Functions */

#include <stdio.h>
#include <Retrace.h>
#include <OSUtils.h>
#include <LowMem.h>
#include "custom.h"
#include "Interrupt.h"
#include "VIA.h"
#include "Screen.h"
#include "RTC.h"

VBLTask2 vMac_VBL;
int      IntCounter = 0;

extern VIA_Ty VIA;
extern UBYTE  vVBL_Int;
extern UBYTE  vSec_Int;
extern int    InterruptNo;

/* Set up interrupts synced to the Vertical Retrace */
int Interrupt_Init (void)
{
  OSErr Err = 0;
  
  vMac_VBL.theTask.qType = vType;
  vMac_VBL.theTask.vblAddr = (VBLUPP) Do_VBL;
  vMac_VBL.theTask.vblCount = 1;
  vMac_VBL.theTask.vblPhase = 0;
  vMac_VBL.theA5 = (long) LMGetCurrentA5();
  
  Err = VInstall((QElemPtr) &vMac_VBL.theTask);
  
  if (Err != 0)
  {
    printf("Sorry, there were errors installing the VBL, %d\n", Err);
    return 1;
  }
  return 0;
}

void Interrupt_Reset (void)
{
  NULL;
}

/* Gets Address of the VBL Structure */
long Get_VBL (void)
{
  inline :
  0x2E88; /* MOVE.L A0,(A7) */
}

/* Perform tasks required at each vertical retrace */
void Do_VBL (void)
{
  long curA5 = 0;
  VBLPtr theVBL;
  
  theVBL = (VBLPtr) Get_VBL();
  curA5 = SetA5(theVBL->theA5);
  
  IntCounter++;
  if (IntCounter == 60)
  {
    IntCounter = 0;
    RTC_Interrupt(); /* Give the RTC a 1 second interrupt */
    Screen_Draw();   /* Tell Screen to Redraw */
    if (vSec_Int)    /* Tell VIA about a 1 second interrupt */
    {
      VIA.IFR |= 0x81; 
/*      specialflags |= SPCFLAG_DOINT;
      InterruptNo = 1; */
    }
    
    if (Button())
      { specialflags |= SPCFLAG_BRK; }
  }
  if (vVBL_Int)
  {
    VIA.IFR |= 0x82; /* Tell VIA about a 1/60th second interrupt */
/*    specialflags |= SPCFLAG_DOINT;
    InterruptNo = 1; */
  }
    
  theVBL->theTask.vblCount = 1;
  curA5 = SetA5(curA5);
}