/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
/* PC - RAM Function Files */

#include <stdio.h>
#include "RAM.h"

UWORD RAM [kRAM_Size/2];

int  RAM_Init (void)
{
  return 0;
}

void  RAM_Reset (void)
{
  NULL;
}

UWORD *RAM_Xlate (CPTR addr)
{
  return RAM + (addr >> 1);
}

UBYTE RAM_GetB (CPTR addr)
{
  return RAM [addr >> 1] >> (addr & 1 ? 0 : 8);
}

UWORD RAM_GetW (CPTR addr)
{
  return RAM [addr >> 1];
}

ULONG RAM_GetL (CPTR addr)
{
  return ((ULONG) RAM [addr >> 1] << 16) | RAM [(addr >> 1)+1];
}

void  RAM_PutB (CPTR addr, UBYTE in)
{
  if (!(addr & 1))
  {
    RAM [addr >> 1] = (RAM [addr >> 1] & 0xff) | (((UWORD) in) << 8);
  }
  else
  {
    RAM [addr >> 1] = (RAM [addr >> 1] & 0xff00) | in;
  }
}

void  RAM_PutW (CPTR addr, UWORD in)
{
  RAM [addr >> 1] = in;
}

void  RAM_PutL (CPTR addr, ULONG in)
{
  RAM [addr >> 1] = in >> 16;
  RAM [(addr >> 1) + 1] = (UWORD) in;
}