/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
/* PC - SCC Function Files */

#include <stdio.h>
#include "SCC.h"

SCC_Ty SCC;
UBYTE SCC_Mode = 0;
UBYTE SCC_Reg = 0;

int  SCC_Init (void)
{
  int Counter = 0;
  
  SCC_Mode = SCC_Reg = 0;
  
  for (Counter = 0; Counter > 16; Counter++)
  {
    SCC.A.RR[Counter] = 0;
    SCC.B.RR[Counter] = 0;
    SCC.A.WR[Counter] = 0;
    SCC.B.WR[Counter] = 0;
  }
  SCC.A.RR[0] = 0x04;
  SCC.B.RR[0] = 0x04;
  return 0;
}

void  SCC_Reset (void)
{
  (void) SCC_Init();
}

UBYTE SCC_GetB (CPTR addr)
{ 
  if ((addr & 1) == 0)
  {
    printf("SCC GB %4lx\n", addr);
    switch (addr > 1)
    {
      case 0 : /* Channel B Control */
        if (SCC_Mode == 1)
        {
          SCC_Mode = 0;
          return SCC_GetBReg();
        }
        else
        {
          SCC_Reg = 0;
          return SCC_GetBReg();
        }
        break;
      case 1 : /* Channel A Control */
        if (SCC_Mode == 1)
        {
          SCC_Mode = 0;
          return SCC_GetAReg();
        }
        else
        {
          SCC_Reg = 0;
          return SCC_GetAReg();
        }
        break;
      case 2 : return 0; break; /* Channel B Data */
      case 3 : return 0; break; /* Channel A Data */
    }
  }
  else
  { 
    SCC_Reset();
    return 0;
  }
}

UWORD SCC_GetW (CPTR addr)
{
  printf("Attempted Phase Adjust\n");
  return 0;
}

ULONG SCC_GetL (CPTR addr)
{
  printf("Attempted Phase Adjust\n");
  return 0;
}

void  SCC_PutB (CPTR addr, UBYTE in)
{
  if ((addr & 1) == 0)
  {
    printf("SCC PB %4lx %2x\n", addr, in);
    switch (addr > 1)
    {
      case 0 : /* Channel B Control */
        if (SCC_Mode == 0)
        {
          SCC_Mode = 1;
          SCC_Reg = in & 0x0F;
          SCC_PutBReg(in & 0xF0);
        }
        else
        {
          SCC_Mode = 0;
          SCC_PutBReg(in);
        }
        break;
      case 1 : /* Channel A Control */
        if (SCC_Mode == 0)
        {
          SCC_Mode = 1;
          SCC_Reg = in & 0x0F;
          SCC_PutAReg(in & 0xF0);
        }
        else
        {
          SCC_Mode = 0;
          SCC_PutAReg(in);
        }
        break;
      case 2 : NULL; break; /* Channel B Data */
      case 3 : NULL; break; /* Channel A Data */
    }
  }
}

void  SCC_PutW (CPTR addr, UWORD in)
{
  printf("Attemped Phase Adjust\n");
}

void  SCC_PutL (CPTR addr, ULONG in)
{
  printf("Attempted Phase Adjust\n");
}

UBYTE SCC_GetAReg (void)
{
  return SCC.A.RR[SCC_Reg];
}

void  SCC_PutAReg (UBYTE in)
{
  SCC.A.WR[SCC_Reg] = in;
}

UBYTE SCC_GetBReg (void)
{
  return SCC.B.RR[SCC_Reg];
}

void  SCC_PutBReg (UBYTE in)
{
  SCC.B.WR[SCC_Reg] = in;
}