/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
/* vMac Custom Code */

#include "sysconfig.h"
#include "sysdeps.h"

#include <ctype.h>
#include <assert.h>

#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"

#include "RAM.h"
#include "ROM.h"
#include "IWM.h"
#include "SCC.h"
#include "SCSI.h"
#include "VIA.h"
#include "RTC.h"
#include "Screen.h"
#include "Interrupt.h"

unsigned long specialflags = 0;
int InterruptNo = -1;

int custominit (void)
{
  int Err = 0;
  Err += RAM_Init();
  Err += ROM_Init();
  Err += IWM_Init();
  Err += SCC_Init();
  Err += SCSI_Init();
  Err += VIA_Init();
  Err += RTC_Init();
  Err += Screen_Init();
  Err += Interrupt_Init();
  InterruptNo = -1;
  return Err;
}

void customreset (void)
{
  RAM_Reset();
  ROM_Reset();
  IWM_Reset();
  SCC_Reset();
  SCSI_Reset();
  VIA_Reset();
  RTC_Reset();
  Screen_Reset();
  Interrupt_Reset();
  InterruptNo = -1;
}

int intlev (void)
{
  int value = InterruptNo;
  
  InterruptNo = -1;
  return value;
}