/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Memory Mapping Code */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "newcpu.h"
#include "readcpu.h"

#include <stdio.h>
#include "IWM.h"
#include "RAM.h"
#include "ROM.h"
#include "SCC.h"
#include "SCSI.h"
#include "VIA.h"

extern UBYTE vOverlay;

UBYTE buserr = 0;

ULONG Get_MM (CPTR addr, Size_Ty Size)
{
  if (vOverlay)
  {
    switch (addr >> 22)
    {
      case 0 : /* ROM */
        if (addr < kROM_Overlay_Top)
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) ROM_GetB (addr % kROM_Size); break;
            case Size_Word : return (UWORD) ROM_GetW (addr % kROM_Size); break;
            case Size_Long : return (ULONG) ROM_GetL (addr % kROM_Size); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
      case 1 : /* ROM, SCSI and RAM */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) ROM_GetB ((addr - kROM_Base) % kROM_Size); break;
            case Size_Word : return (UWORD) ROM_GetW ((addr - kROM_Base) % kROM_Size); break;
            case Size_Long : return (ULONG) ROM_GetL ((addr - kROM_Base) % kROM_Size); break;
          }
        }
        if ((addr >= kRAM_Overlay_Base) && (addr < kRAM_Overlay_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) RAM_GetB ((addr - kRAM_Overlay_Base) % kRAM_Size); break;
            case Size_Word : return (UWORD) RAM_GetW ((addr - kRAM_Overlay_Base) % kRAM_Size); break;
            case Size_Long : return (ULONG) RAM_GetL ((addr - kRAM_Overlay_Base) % kRAM_Size); break;
          }
        }
        if ((addr >= kSCSI_Block_Base) && (addr < kSCSI_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) SCSI_GetB (addr - kSCSI_Block_Base); break;
            case Size_Word : return (UWORD) SCSI_GetW (addr - kSCSI_Block_Base); break;
            case Size_Long : return (ULONG) SCSI_GetL (addr - kSCSI_Block_Base); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
      case 2 : /* SCC */
        if ((addr >= kSCCRd_Block_Base) && (addr < kSCCRd_Block_Top)) /* Read Only Address */
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) SCC_GetB ((addr - kSCCRdBase) % kSCC_Size); break;
            case Size_Word : return (UWORD) SCC_GetW ((addr - kSCCRdBase) % kSCC_Size); break;
            case Size_Long : return (ULONG) SCC_GetL ((addr - kSCCRdBase) % kSCC_Size); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
		return 0;
        break;
      case 3 : /* IWM and VIA */
        if ((addr >= kVIA_Block_Base) && (addr < kVIA_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) VIA_GetB ((addr - kVIA_Base) % kVIA_Size); break;
            case Size_Word : return (UWORD) VIA_GetW ((addr - kVIA_Base) % kVIA_Size); break;
            case Size_Long : return (ULONG) VIA_GetL ((addr - kVIA_Base) % kVIA_Size); break;
          }
        }
        if ((addr >= kIWM_Block_Base) && (addr < kIWM_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) IWM_GetB ((addr - kIWM_Base) % kIWM_Size); break;
            case Size_Word : return (UWORD) IWM_GetW ((addr - kIWM_Base) % kIWM_Size); break;
            case Size_Long : return (ULONG) IWM_GetL ((addr - kIWM_Base) % kIWM_Size); break;
          }
        }
        if ((addr >= kAutoVector_Base) && (addr < kAutoVector_Top))
        { 
          Exception(regs.intmask+24);
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
    }
  }
  else
  {
    switch (addr >> 22)
    {
      case 0 : /* RAM */
        if (addr < kRAM_Top)
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) RAM_GetB (addr % kRAM_Size); break;
            case Size_Word : return (UWORD) RAM_GetW (addr % kRAM_Size); break;
            case Size_Long : return (ULONG) RAM_GetL (addr % kRAM_Size); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
      case 1 : /* ROM and SCSI */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) ROM_GetB ((addr - kROM_Base) % kROM_Size); break;
            case Size_Word : return (UWORD) ROM_GetW ((addr - kROM_Base) % kROM_Size); break;
            case Size_Long : return (ULONG) ROM_GetL ((addr - kROM_Base) % kROM_Size); break;
          }
        }
        if ((addr >= kSCSI_Block_Base) && (addr < kSCSI_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) SCSI_GetB (addr - kSCSI_Block_Base); break;
            case Size_Word : return (UWORD) SCSI_GetW (addr - kSCSI_Block_Base); break;
            case Size_Long : return (ULONG) SCSI_GetL (addr - kSCSI_Block_Base); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
      case 2 : /* SCC */
        if ((addr >= kSCCRd_Block_Base) && (addr < kSCCRd_Block_Top)) /* Read Only Address */
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) SCC_GetB ((addr - kSCCRdBase) % kSCC_Size); break;
            case Size_Word : return (UWORD) SCC_GetW ((addr - kSCCRdBase) % kSCC_Size); break;
            case Size_Long : return (ULONG) SCC_GetL ((addr - kSCCRdBase) % kSCC_Size); break;
          }
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
		return 0;
        break;
      case 3 : /* IWM and VIA */
        if ((addr >= kVIA_Block_Base) && (addr < kVIA_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) VIA_GetB ((addr - kVIA_Base) % kVIA_Size); break;
            case Size_Word : return (UWORD) VIA_GetW ((addr - kVIA_Base) % kVIA_Size); break;
            case Size_Long : return (ULONG) VIA_GetL ((addr - kVIA_Base) % kVIA_Size); break;
          }
        }
        if ((addr >= kIWM_Block_Base) && (addr < kIWM_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : return (UBYTE) IWM_GetB ((addr - kIWM_Base) % kIWM_Size); break;
            case Size_Word : return (UWORD) IWM_GetW ((addr - kIWM_Base) % kIWM_Size); break;
            case Size_Long : return (ULONG) IWM_GetL ((addr - kIWM_Base) % kIWM_Size); break;
          }
        }
        if ((addr >= kAutoVector_Base) && (addr < kAutoVector_Top))
        {
          Exception(regs.intmask+24);
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx\n", addr); break;
          case Size_Word : printf("Word Access at %8lx\n", addr); break;
          case Size_Long : printf("Long Access at %8lx\n", addr); break;
        }
        return 0;
        break;
    }
  }
}

void  Put_MM (CPTR addr, Size_Ty Size, ULONG in)
{
  if (vOverlay)
  {
    switch (addr >> 22)
    {
      case 0 : /* ROM */
        if (addr < kROM_Overlay_Top)
        {
          switch (Size)
          {
            case Size_Byte : ROM_PutB (addr % kROM_Size, (UBYTE) in); break;
            case Size_Word : ROM_PutW (addr % kROM_Size, (UWORD) in); break;
            case Size_Long : ROM_PutL (addr % kROM_Size, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 1 : /* ROM, SCSI and RAM */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          switch (Size)
          {
            case Size_Byte : ROM_PutB ((addr - kROM_Base) % kROM_Size, (UBYTE) in); break;
            case Size_Word : ROM_PutW ((addr - kROM_Base) % kROM_Size, (UWORD) in); break;
            case Size_Long : ROM_PutL ((addr - kROM_Base) % kROM_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kRAM_Overlay_Base) && (addr < kRAM_Overlay_Top))
        {
          switch (Size)
          {
            case Size_Byte : RAM_PutB ((addr - kRAM_Overlay_Base) % kRAM_Size, (UBYTE) in); break;
            case Size_Word : RAM_PutW ((addr - kRAM_Overlay_Base) % kRAM_Size, (UWORD) in); break;
            case Size_Long : RAM_PutL ((addr - kRAM_Overlay_Base) % kRAM_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kSCSI_Block_Base) && (addr < kSCSI_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : SCSI_PutB (addr - kSCSI_Block_Base, (UBYTE) in); break;
            case Size_Word : SCSI_PutW (addr - kSCSI_Block_Base, (UWORD) in); break;
            case Size_Long : SCSI_PutL (addr - kSCSI_Block_Base, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 2 : /* SCC */
        if ((addr >= kSCCWr_Block_Base) && (addr < kSCCWr_Block_Top)) /* Write Only Address */
        {
          switch (Size)
          {
            case Size_Byte : SCC_PutB ((addr - kSCCWrBase) % kSCC_Size, (UBYTE) in); break;
            case Size_Word : SCC_PutW ((addr - kSCCWrBase) % kSCC_Size, (UWORD) in); break;
            case Size_Long : SCC_PutL ((addr - kSCCWrBase) % kSCC_Size, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 3 : /* IWM and VIA */
        if ((addr >= kVIA_Block_Base) && (addr < kVIA_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : VIA_PutB ((addr - kVIA_Base) % kVIA_Size, (UBYTE) in); break;
            case Size_Word : VIA_PutW ((addr - kVIA_Base) % kVIA_Size, (UWORD) in); break;
            case Size_Long : VIA_PutL ((addr - kVIA_Base) % kVIA_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kIWM_Block_Base) && (addr < kIWM_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : IWM_PutB ((addr - kIWM_Base) % kIWM_Size, (UBYTE) in); break;
            case Size_Word : IWM_PutW ((addr - kIWM_Base) % kIWM_Size, (UWORD) in); break;
            case Size_Long : IWM_PutL ((addr - kIWM_Base) % kIWM_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kAutoVector_Base) && (addr < kAutoVector_Top))
        {
          Exception(regs.intmask+24);
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
    }
  }
  else
  {
    switch (addr >> 22)
    {
      case 0 : /* RAM */
        if (addr < kRAM_Top)
        {
          switch (Size)
          {
            case Size_Byte : RAM_PutB (addr % kRAM_Size, (UBYTE) in); break;
            case Size_Word : RAM_PutW (addr % kRAM_Size, (UWORD) in); break;
            case Size_Long : RAM_PutL (addr % kRAM_Size, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 1 : /* ROM and SCSI */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          switch (Size)
          {
            case Size_Byte : ROM_PutB ((addr - kROM_Base) % kROM_Size, (UBYTE) in); break;
            case Size_Word : ROM_PutW ((addr - kROM_Base) % kROM_Size, (UWORD) in); break;
            case Size_Long : ROM_PutL ((addr - kROM_Base) % kROM_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kSCSI_Block_Base) && (addr < kSCSI_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : SCSI_PutB (addr - kSCSI_Block_Base, (UBYTE) in); break;
            case Size_Word : SCSI_PutW (addr - kSCSI_Block_Base, (UWORD) in); break;
            case Size_Long : SCSI_PutL (addr - kSCSI_Block_Base, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 2 : /* SCC */
        if ((addr >= kSCCWr_Block_Base) && (addr < kSCCWr_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : SCC_PutB ((addr - kSCCWrBase) % kSCC_Size, (UBYTE) in); break;
            case Size_Word : SCC_PutW ((addr - kSCCWrBase) % kSCC_Size, (UWORD) in); break;
            case Size_Long : SCC_PutL ((addr - kSCCWrBase) % kSCC_Size, (ULONG) in); break;
          }
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
      case 3 : /* IWM and VIA */
	    if ((addr >= kVIA_Block_Base) && (addr < kVIA_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : VIA_PutB ((addr - kVIA_Base) % kVIA_Size, (UBYTE) in); break;
            case Size_Word : VIA_PutW ((addr - kVIA_Base) % kVIA_Size, (UWORD) in); break;
            case Size_Long : VIA_PutL ((addr - kVIA_Base) % kVIA_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kIWM_Block_Base) && (addr < kIWM_Block_Top))
        {
          switch (Size)
          {
            case Size_Byte : IWM_PutB ((addr - kIWM_Base) % kIWM_Size, (UBYTE) in); break;
            case Size_Word : IWM_PutW ((addr - kIWM_Base) % kIWM_Size, (UWORD) in); break;
            case Size_Long : IWM_PutL ((addr - kIWM_Base) % kIWM_Size, (ULONG) in); break;
          }
          return;
        }
        if ((addr >= kAutoVector_Base) && (addr < kAutoVector_Top))
        {
          Exception(regs.intmask+24);
          return;
        }
        switch (Size)
        {
          case Size_Byte : printf("Byte Access at %8lx, %2lx\n", addr, (UBYTE) in); break;
          case Size_Word : printf("Word Access at %8lx, %4lx\n", addr, (UWORD) in); break;
          case Size_Long : printf("Long Access at %8lx, %8lx\n", addr, (ULONG) in); break;
        }
        break;
    }
  }
}

/* UAE 0.6 Emulation Direct Memory Access Function */

UWORD *get_real_address (CPTR addr)
{
  if (vOverlay)
  {
    switch (addr >> 22)
    {
      case 0 : /* ROM */
        if (addr < kROM_Overlay_Top)
        {
          return ROM_Xlate (addr % kROM_Size);
        }
		return NULL;
        break;
      case 1 : /* ROM, SCSI and RAM */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          return ROM_Xlate ((addr - kROM_Base) % kROM_Size);
        }
        if ((addr >= kRAM_Overlay_Base) && (addr < kRAM_Overlay_Top))
        {
          return RAM_Xlate ((addr - kRAM_Overlay_Base) % kRAM_Size);
        }
        return NULL;
        break;
      case 2 : /* SCC */
        return NULL;
        break;
      case 3 : /* IWM and VIA */
        return NULL;
        break;
    }
  }
  else
  {
    switch (addr >> 22)
    {
      case 0 : /* RAM */
        if (addr < kRAM_Top)
        {
          return RAM_Xlate (addr % kRAM_Size);
        }
		return NULL;
        break;
      case 1 : /* ROM and SCSI */
        if ((addr >= kROM_Base) && (addr < kROM_Top))
        {
          return ROM_Xlate ((addr - kROM_Base) % kROM_Size);
        }
        return NULL;
        break;
      case 2 : /* SCC */
        return NULL;
        break;
      case 3 : /* IWM and VIA */
        return NULL;
        break;
    }
  }
}

/* UAE 0.6 68K Emulator Memory Access Functions */

ULONG get_long(CPTR addr)
{
  return (ULONG) Get_MM(addr & kMemory_Extent,Size_Long);
}

UWORD get_word(CPTR addr)
{
  return (UWORD) Get_MM(addr & kMemory_Extent,Size_Word);
}

UBYTE get_byte(CPTR addr)
{
  return (UBYTE) Get_MM(addr & kMemory_Extent,Size_Byte);
}

void put_long(CPTR addr, ULONG in)
{
  Put_MM(addr & kMemory_Extent, Size_Long, (ULONG) in);
}

void put_word(CPTR addr, UWORD in)
{
  Put_MM(addr & kMemory_Extent, Size_Word, (ULONG) in);
}

void put_byte(CPTR addr, UBYTE in)
{
  Put_MM(addr & kMemory_Extent, Size_Byte, (ULONG) in);
}